//
//  MotionTracker.h
//  CreepyGirl
//
//  Created by Curtis Jones on 2008.03.31.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CreepyTypes.h"

#define MOTION_THRESHHOLD 20
#define IMAGE_COLS 640
#define IMAGE_ROWS 480
#define MARKED_PIXEL_ARRAY_SIZE 66
#define MAX_TRACKED_OBJECTS 100

#define COLOR_CHANGE_THRESHOLD 30
#define DISTANCE_CHANGE_THRESHOLD 5
#define COLOR_WEIGHT 1
#define DISTANCE_WEIGHT 5
#define AREA_WEIGHT 2

#define PIXEL_MARKED 0xFF00
#define PIXEL_OBJECT 0xFF

#define SCAN_RANGE 5

@interface MotionTracker : NSObject
{
	
	// for testing. tempory. can be removed when we
	// dump the testing code.
	//
	NSPoint mLastPoint;
	int mVertDir;
	int mHorzDir;
	int mTrackedObjectCount;
	
//NSPoint mLastKnownPoint;										// the last know location of the current tracked object
	TrackedObject mCurTrackedObject;						// the current tracked object
	
	NSPoint mMarkedPixelArray[MARKED_PIXEL_ARRAY_SIZE];
	
	TrackedObject mTrackedObjects[MAX_TRACKED_OBJECTS];
	TrackedObject mTrackedObjectsPrev[MAX_TRACKED_OBJECTS];
	
	unsigned int * mFrameNew;
	unsigned int * mFrameOld;
	
	CreepyPixel * mMarks;
}

- (void)testScan001;
- (void)testCompare001;

- (NSPoint)addFrameData:(const unsigned char *)data width:(int)width height:(int)height bitsPerPixel:(int)bits;
- (void)scanMarksForFrame:(CreepyPixel *)frame;
- (int)findNearByMarkedPixels:(int)col vert:(int)row objId:(int *)objid array:(NSPoint *)pointArray arraySize:(int)arraySize;
- (void)assignPixelsToObjectId:(int)objid array:(NSPoint *)pixelArray arraySize:(int)arraySize frame:(CreepyPixel *)frame;
- (void)calculateCentersAndAreasForObjects:(TrackedObject *)objectsArray arraySize:(int)size;
- (void)calculateCenterAndAreaForObject:(TrackedObject *)object;
- (void)compareOldFrame:(unsigned int *)oldFrame withNewFrame:(unsigned int *)newFrame;
- (NSPoint)findPixelLike:(CreepyColor)aColor nearRow:(int)aRow andCol:(int)aCol inFrame:(unsigned int *)aFrame;
- (TrackedObject)findMostProminentObject:(TrackedObject *)objectsArray objectCount:(int)objectCount;
- (TrackedObject)findObjectLike:(TrackedObject)targetObject fromObjects:(TrackedObject *)objectsArray objectCount:(int)objectCount;

@end
